/*****************************************************************************/
/*                                                                           */
/* FILENAME                                                                  */
/* 	 main.c                                                                  */
/*                                                                           */
/* DESCRIPTION                                                               */
/*   TMS320C5515 USB Stick Application 20 Spectrum Analyser.                 */
/*   Take microphone input and send to headphones with ring modulation.      */
/*                                                                           */
/* REVISION                                                                  */
/*   Revision: 1.00	                                                         */
/*   Author  : Richard Sikora                                                */
/*---------------------------------------------------------------------------*/
/*                                                                           */
/* HISTORY                                                                   */
/*   Revision: 1.00                                                          */
/*   15th September 2010. Created from TMS320C5505 USB Stick code.           */
/*                                                                           */
/*****************************************************************************/
/*
 * Copyright (C) 2010 Texas Instruments Incorporated - http://www.ti.com/ 
 * 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 *  modification, are permitted provided that the following conditions 
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the   
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
*/

#include "stdio.h"
#include "usbstk5515.h"
#include "usbstk5515_led.h"
#include "aic3204.h"
#include "PLL.h"
//#include "bargraph.h"
#include "oled.h"
#include "pushbuttons.h"
#include "stereo.h"
#include "dsplib.h"

#include <math.h>
#include "sar.h"


#include "IIR.h"

Int16 left_input;
Int16 right_input;
Int16 left_output;
Int16 right_output;
Int16 mono_input;


#define SAMPLES_PER_SECOND 48000
#define GAIN_IN_dB 0

//unsigned long int i = 0;

unsigned int Step = 0; 
unsigned int LastStep = 99;

int fo = 12000.0;
int B3dB = 3000.0;

char *napis1 = "1                   ";
char *napis2 = "2                   ";

signed int wsp1[6] = {0, 0, 0, 0, 0, 0 };
signed int x1[3] = { 0, 0, 0 };  // próbki wejściowe
signed int y1[3] = { 0, 0, 0 };  // próbki wyjściowe


signed int wsp2[6] = {0, 0, 0, 0, 0, 0 };
signed int x2[3] = { 0, 0, 0 };  // próbki wejściowe
signed int y2[3] = { 0, 0, 0 };  // próbki wyjściowe
                                       
signed int x3[3] = { 0, 0, 0 };  // próbki wejściowe
signed int y3[3] = { 0, 0, 0 };  // próbki wyjściowe                                       
                                       

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  main( )                                                                 *
 *                                                                          *
 * ------------------------------------------------------------------------ */
void main( void ) 
 {
    /* Initialize BSL */
    USBSTK5515_init( );
	
	/* Initialize PLL */
	pll_frequency_setup(120);

    /* Initialise hardware interface and I2C for code */
    aic3204_hardware_init();
    
    /* Initialise the AIC3204 codec */
	aic3204_init(); 
	
	/* Turn off the 4 coloured LEDs */
	USBSTK5515_ULED_init();
	
	/* Initialise the OLED LCD display */
	oled_init();
	SAR_init();
	/* Flush display buffer */
    oled_display_message("                 ", "                   ");
    
    printf("\n\nLaboratorium FCiPS\n");
    printf( "Ćwiczenie Filtry IIR\n" );

	/* Setup sampling frequency and  gain for microphone */
    set_sampling_frequency_and_gain(SAMPLES_PER_SECOND, GAIN_IN_dB);

    oled_display_message("Laboratorium FCiPS ", "Filtry IIR         ");

	/* New. Add descriptive text */ 
	//puts("\n Wciśnij SW1 <-- , SW2 -->, SW1 + SW2 for reset\n");
	puts(" Kanał prawy jedna sekcja SOS");
	puts(" Kanał lewy dwie sekcje SOS kaskadowo");
    puts(" Przełączane jest pasmo 3 dB filtrów B3dB od 500 Hz do 50 Hz");
    puts(" Częstotliwość środkowa wszystkich sekcji fo = 10 kHz");

      
	/* Default to XF LED off */
	asm(" bclr XF");
    
 	for ( ;; )
 	{

     aic3204_codec_read(&left_input, &right_input); // Configured for one interrupt per two channels.  
     mono_input = stereo_to_mono(left_input, right_input);
        
     Step = pushbuttons_read(2);
  
	  if ( Step == 1 )
        {
         if ( Step != LastStep )
          {
           oled_display_message("L = L; bez zmiany ", "P = P; bez zmiany ");
           puts("\n0 Transmisja sygnału z wejścia na wyjście umożliwia zerowanie przyrządu");
           LastStep = Step;
          }	
         left_output = left_input;      // Straight trough. No processing.
	     right_output = right_input;

	    } 
      if ( Step == 2)
        {
         if ( Step != LastStep )
          {         
           	fo = 10000;
           	B3dB = 150;
           	oled_display_message("patrz na konsole  ", "i wpisz parametry  ");
            
            printf("Podaj częstotliwość środkową lewego filtru [Hz] fo = ");
    		scanf("%d", &fo);
    		printf("Podaj pasmo 3dB lewego filtru [Hz] B3Db = ");
    		scanf("%d", &B3dB);
           	wsp_SOS_BP_Q14(fo, B3dB, SAMPLES_PER_SECOND, wsp1);          	
           	sprintf(napis1, "f = %5d, B = %4d ", fo, B3dB);
           	
           	printf("Podaj częstotliwość środkową prawego filtru [Hz] fo = ");
    		scanf("%d", &fo);
    		printf("Podaj pasmo 3dB prawego filtru [Hz] B3dB = ");
    		scanf("%d", &B3dB);
           	//wsp_SOS_BS(fo, B3dB, SAMPLES_PER_SECOND, wsp2);
           	sprintf(napis2, "f = %5d, B = %4d ", fo, B3dB);
           	
           	
           	wsp_LP(fo, SAMPLES_PER_SECOND, wsp2);
           	
           	
           	
            
            oled_display_message(napis1, napis2);
            printf("\nFiltry uruchomione i można je mierzyć\n");

           	LastStep = Step;
          }	

         left_output  = IIR_I_order(x1, y1, wsp2, left_input);
         //left_output  = SOS(x3, y3, wsp2, left_output);
         right_output = IIR_I_orderLONG(x2, y2, wsp2, right_input);

	    }   
	    
     aic3204_codec_write(left_output, right_output);

 	}

   /* Disable I2S and put codec into reset */ 
    aic3204_disable();

    printf( "\n***Program has Terminated***\n" );
    
    oled_display_message("PROGRAM HAS        ", "TERMINATED        ");
    
    SW_BREAKPOINT;
}

/* ------------------------------------------------------------------------ *
 *                                                                          *
 *  End of main.c                                                           *
 *                                                                          *
 * ------------------------------------------------------------------------ */
